conoutf("Addon test");

setvar("luaoverridemusic", 1, true);

math.randomseed(os.time());

local function findSongsInDir(path)
	if not IsDirectory(path) then
		return;
	end
	
	for eachFile in DirectoryList(path) do
		if string.find(eachFile, ".%.mp3$") or string.find(eachFile, ".%.ogg$") then
			-- print("Adding ", eachFile);
			table.insert(MusicPlayer_trackList, path .. "/" .. eachFile);
		elseif eachFile ~= "." and eachFile ~= ".." then
			findSongsInDir(path .. "/" .. eachFile);
		end
	end
end

function MusicPlayer_FindTracks(baseDir)
	baseDir = baseDir or "songs";
	MusicPlayer_trackList = {};
	findSongsInDir(baseDir);
end

-- MusicPlayer_cacheTrackList = true;

if MusicPlayer_trackList == nil or MusicPlayer_cacheTrackList == false then
	MusicPlayer_searchDir = MusicPlayer_searchDir or "songs";
	MusicPlayer_FindTracks(MusicPlayer_searchDir);
end

function MusicPlayer_PlayTrack()
	local randSongNum = math.random(#MusicPlayer_trackList);
	local track = MusicPlayer_trackList[randSongNum];
	conoutf("Now playing: " .. track);
	StartMusic(track);
end

AddEventHook("MUSICDONE", MusicPlayer_PlayTrack);
AddTimer(function()
	MusicPlayer_PlayTrack();
end, 1000);

MusicPlayer_dlg = UIDialog(nil, 300, 200);
MusicPlayer_dlg:SetTitle("Music Player");
local y = 0;
local btnheight = 35;
MusicPlayer_dlg.btnNextSong = UIButton(MusicPlayer_dlg, 0, y, 100, btnheight, "Next track");
MusicPlayer_dlg.btnNextSong:RegisterEvent("MouseDown", function()
	MusicPlayer_PlayTrack();
end);
y = y + btnheight;
MusicPlayer_dlg.btnHide = UIButton(MusicPlayer_dlg, 0, y, 100, btnheight, "Hide");
MusicPlayer_dlg.btnHide:RegisterEvent("MouseDown", function(self)
	local parent=self:GetParent();
	parent:Hide();
end);
y = y + btnheight;
MusicPlayer_dlg.btnUnbind = UIButton(MusicPlayer_dlg, 0, y, 100, btnheight, "Unbind M");
MusicPlayer_dlg.btnUnbind:RegisterEvent("MouseDown", function()
	runscript("bind M []");
end);
 
MusicPlayer_dlg:ShowAll();
MusicPlayer_dlg:MoveTo(100,122);

function MusicPlayer_dlg:Toggle()
	if self:IsHidden() then
		self:ShowAll();
	else
		self:Hide();
	end
end

-- bind Music Player dialog toggle if 'M' is free
local mBind = FindBind("M");
if mBind.actions[1] == "" then
	runscript("bind M [ lua MusicPlayer_dlg:Toggle() ]");
end