
local GUI_EVENT_CHECK = {
    ["onclick"] = {},
    ["onrelease"] = {},
    ["onmouseover"] = {},
    ["onmouseaway"] = {}
}

function registerEvent(frame, eventName)
    local list = GUI_EVENT_CHECK[eventName]
    if list == nil then
        error("`%s' is not a valid event name", eventName)
    end
    table.insert(list, frame)
end

local function gui_MouseButton(btn, state)
    local cx, cy = GetCursorX(), GetCursorY()
    if state ~= 0 then
        for index, frame in pairs(GUI_EVENT_CHECK["onclick"]) do
            if frame:PointInRect(cx, cy) then
                frame:onclick(btn, cx, cy)
                frame.__hasclick = true
            end
        end
    else
        for index, frame in pairs(GUI_EVENT_CHECK["onrelease"]) do
            if frame.__hasclick then
                frame:onrelease(btn, cx, cy)
                frame.__hasclick = false
            end
        end
    end
end

local function gui_MouseMotion(x,y,xrel,yrel)
    x,y = GetCursorPosition()
    for index, frame in pairs(GUI_EVENT_CHECK["onmouseover"]) do
        if frame:PointInRect(x, y) and not frame.__hadmouse then
            frame:onmouseover(x,y,xrel,yrel)
            frame.__hadmouse = true
        elseif not frame:PointInRect(x,y) and frame.__hadmouse then
            if frame.onmouseaway then frame:onmouseaway() end
            frame.__hadmouse = false
        end
    end
end

AddEventHook("MouseButton", gui_MouseButton)
AddEventHook("MouseMotion", gui_MouseMotion)


