-- testing for frame UI classes goes here
-- run it with /lua "luascripts/testhuds.lua"

function newfpsdisplay()
	-- hide the fps text
	setvar("luahidefps", "1", true)
	fpsLabel = UILabel(nil, "...", 0.4, 255, 128, 255)
	local scrw, scrh = GetScreenResolution()
	fpsLabel:Show()
	local updateFps
	updateFps = function()
		local newtxt = tostring(GetFps(true))
		local neww, newh = GetTextBounds(newtxt)
		fpsLabel:SetText(newtxt)
		fpsLabel:Resize(neww, newh)
		fpsLabel:MoveTo(scrw - fpsLabel:GetWidth(), scrh - fpsLabel:GetHeight())
        -- "chain" timer every 250 millis
		AddTimer(updateFps, 250)
	end
	updateFps()
end
newfpsdisplay()

--LUA HUD

function hud_frame()
--box--
	local boxw = (GetScreenResolution()/2+30)
	local boxh = 50
	local hud_frame = UIFrame(nil, boxw, boxh, nil)
    hud_frame:SetAlpha(128)
    AddTopLevelFrame(hud_frame, "hud_frame"); -- keeps it from disappearing
	hud_frame:MoveTo(1, 749)
	hud_frame:SetColor(0,128,0)
	hud_frame:Show()
end
hud_frame()

function hud_health()
--Healthbar--
	local scrw = (GetScreenResolution()/2-50)
	local scrh = 15
	local hud_health = UIFrame(nil, scrw, scrh, nil)
    hud_health:SetAlpha(128) -- so i can see what i type (until input text can be modded)
    AddTopLevelFrame(hud_health, "hud_health"); -- keeps it from disappearing
	hud_health:MoveTo(80, 755)
	hud_health:SetColor(128,0,0)
	hud_health:Show()
	local player1 = GetPlayer()
	AddEventHook("SvDamage", function(d,t)
		if player1:is(d) then
			hud_health:SetWidth(scrw * player1.health / player1.maxhealth)
		end
	end)
end
hud_health()

-- make a floating button on the center left of screen
--

function button_test()
    local scr_w, scr_h = GetScreenResolution()
    local normal_text = "Click to start new map"
    testButton = UIFrame(nil, 200, 120, nil)
    testButton:SetColor(192,192,192)
    testButton.text = UILabel(testButton, normal_text, 0.45, 0, 192, 255)
    testButton:Resize(testButton.text:GetWidth(), testButton.text:GetHeight())
    testButton:MoveTo(0, scr_h / 2 - testButton:GetHeight() / 2)
    testButton.text:Show()
    testButton:Show()

    testButton.onclick = function(btn)
        conoutf("You clicked on me! (%s)", tostring(testButton))
        testButton:SetColor(128,128,128)
        NewMap(12)
    end

    testButton.onmouseover = function(x,y)
        testButton.text:SetText(normal_text, 255, 192, 0)
    end

    testButton.onmouseaway = function()
        testButton.text:SetText(normal_text, 0, 192, 255)
    end

    testButton.onrelease = function()
        testButton:SetColor(192,192,192)
    end

    require "luatests/guiprototypes"

    registerEvent(testButton, "onclick")
    registerEvent(testButton, "onmouseover")
    registerEvent(testButton, "onrelease")
    registerEvent(testButton, "onmouseaway")
end

button_test()

