"function SafeTocFile(name)" "\n"
"	local safepath = name:gsub(\"\\\\\", \"/\")" "\n"
"	safepath = safepath:gsub(\"%.%./\", \"\")" "\n"
"	safepath = safepath:gsub(\"^%a:/\", \"\")" "\n"
"	safepath = safepath:gsub(\"^/\", \"\")" "\n"
"	return safepath" "\n"
"end" "\n"
"" "\n"
"function ParseTocLine(line, data)" "\n"
"    if line:find(\"##\") then" "\n"
"        for attr, val in line:gfind(\"(%S+):[%s]*(.+)\") do" "\n"
"            --print(attr .. \"=\" .. val)" "\n"
"            if attr == \"Interface\" then" "\n"
"				data.interface = tonumber(val)" "\n"
"			elseif attr == \"Version\" then" "\n"
"				data.version = {}" "\n"
"				for ve in val:gfind(\"[%d]+\") do" "\n"
"					table.insert(data.version, tonumber(ve))" "\n"
"				end" "\n"
"            elseif attr == \"SavedVariables\" then" "\n"
"				data.savedvars = {}" "\n"
"				for varname in val:gfind(\"[%w_]+\") do" "\n"
"					table.insert(data.savedvars, varname)" "\n"
"				end" "\n"
"			elseif attr == \"Dependencies\" then" "\n"
"				data.depends = {}" "\n"
"				-- ignore the versions for now" "\n"
"				for dep,vers in val:gfind(\"([%a_]+)\") do" "\n"
"					table.insert(data.depends, dep)" "\n"
"				end" "\n"
"			else" "\n"
"				data[attr:lower()] = val" "\n"
"			end" "\n"
"        end" "\n"
"    elseif line:find(\"%.lua$\") then" "\n"
"		if data.luafiles == nil then" "\n"
"			data.luafiles = {}" "\n"
"		end" "\n"
"		table.insert(data.luafiles, SafeTocFile(line))" "\n"
"	elseif line:find(\"%.cfg$\") then" "\n"
"		if data.cfgfiles == nil then" "\n"
"			data.cfgfiles = {}" "\n"
"		end" "\n"
"		table.insert(data.cfgfiles, SafeTocFile(line))" "\n"
"	end" "\n"
"end" "\n"
"" "\n"
"function ParseTocFile(filename)" "\n"
"    local f = io.open(filename)" "\n"
"    local data = {}" "\n"
"	data.luafiles = {}" "\n"
"	data.cfgfiles = {}" "\n"
"    for line in f:lines() do" "\n"
"		ParseTocLine(line, data)" "\n"
"    end" "\n"
"    f:close()" "\n"
"	return data" "\n"
"end" "\n"
"" "\n"
"function PrintTocData(data)" "\n"
"	print(\"===Printing TOC file===\")" "\n"
"	for k,v in pairs(data) do" "\n"
"		print(string.format(\"%s=%s\", tostring(k), tostring(v)))" "\n"
"		if type(v) == \"table\" then" "\n"
"			for key,val in pairs(v) do" "\n"
"				print(string.format(\"\\t%s=%s\", tostring(key), tostring(val)))" "\n"
"			end" "\n"
"		end" "\n"
"	end" "\n"
"end" "\n"
"" "\n"
"function WriteParseTocLib()" "\n"
"	infile = io.open('parsetoc.lua', 'r')" "\n"
"	outfile = io.open('parsetoc.txt', 'w')" "\n"
"	for line in infile:lines() do" "\n"
"		local formattedsz = string.format(\"%q \\\"\\\\n\\\"\\n\", line)" "\n"
"		outfile:write(formattedsz)" "\n"
"		print(formattedsz)" "\n"
"	end" "\n"
"	infile:close()" "\n"
"	outfile:close()" "\n"
"end" "\n"
"" "\n"
