// set of macros to simplify class binding for lua*Class*.cpp files
// should be the LAST include in the cpp file

#define ClassMethod(CLASSNAME, MNAME) \
    static int lua_##CLASSNAME##_##MNAME (lua_State* L)
#define ClassMetamethod(CLASSNAME, MNAME) \
    static int lua_##CLASSNAME##_mm##MNAME (lua_State* L)

#define BeginMethods(CNAME) \
    static const luaL_Reg lua_##CNAME##_methods[] = {
#define Method(CLASSNAME, MNAME) { #MNAME, lua_##CLASSNAME##_##MNAME },
#define EndMethods {NULL,NULL} };

#define Methods(CNAME) lua_##CNAME##_methods
#define Metamethods(CNAME) lua_##CNAME##_metamethods

#define BeginMetamethods(CLASSNAME) \
    static const luaL_Reg lua_##CLASSNAME##_metamethods[] = {
#define Metamethod(CLASSNAME, MNAME) { #MNAME, lua_##CLASSNAME##_mm##MNAME },
#define EndMetamethods {NULL, NULL} };

#define ClassProperty(GETORSET, CLASSNAME, PROPNAME) \
    static int lua_##CLASSNAME##_##GETORSET##_##PROPNAME(lua_State* L)

#define BindClassProperty(GETORSET, CLASSNAME, PROPNAME) \
    classbind::bind##GETORSET##property(L, #CLASSNAME, #PROPNAME, \
    lua_##CLASSNAME##_##GETORSET##_##PROPNAME)



